var MODULE_NAME  = "Goto global variable declaration";
var MODULE_VER   = "1.0";
var MODULE_TITLE = "Searchs for global variable declaration.";

var ed;

function Init() {
    menuName = "&" + MODULE_NAME;
    subMenu = "&" + "DMIS";
    addMenuItem(menuName, subMenu, "main", "CTRL+SHIFT+G");
}


function main()
{
	 ed = newEditor();
	 ed.assignActiveEditor();
	
	 saveBeforeJumpPos( ed );

	 var selVar = ed.selText();
	 var foundVar = 0;

	 var prjCount = projectFilesCount();
	 var prjIdx = 0;
	 var fso = new ActiveXObject("Scripting.FileSystemObject");
	 
	 filesLoop :
	 while ( prjIdx < prjCount )
	 {
	    var prjFileName = projectFiles( prjIdx );
	    var fs = fso.OpenTextFile( prjFileName, 1, false );
	    var allText = fs.ReadAll();
	    var allLines = allText.split( '\n' );
	    var ln = 0;
		 while ( ln < allLines.length )
		 {
		     var actline = allLines[ln];
		     if ( isDeclarationOfVar( actline, selVar ) )
		     {
			      foundVar = ln+1;
			      break filesLoop;
			  }
			  ln++;
		 }
		 prjIdx++;
	 }
	 
	 if ( foundVar != 0 )
	 {
	     var varEditor = newEditor();
	     if ( isDeclFileOpened( prjFileName ) )
	     {
	         varEditor.assignEditorByName( prjFileName );
		  }
		  else
		  {
		      varEditor.openFile( prjFileName );
		  }
		  varEditor.activate();
		  varEditor.setCaretPos( 0, foundVar );
		  return true;
	 }
	 echo( 'Declaration of global variable \'' + selVar + '\' not found in current project! ' );
	 return false;

}











function isDeclarationOfVar( line, selVar )
{
    var reDecl = new RegExp( "(DECL)" );
    var reLocal = new RegExp( "(LOCAL)" );
    var reVar  = new RegExp( "[ ,]*(" + selVar + ")[$ ,\[]*" );
    if ( line.search( reDecl ) != -1 && line.search( reLocal ) == -1 && line.search( reVar ) != -1 )
    {
        return true;
	 }
	 return false;
}



function isDeclFileOpened( filename )
{
     var isOpened = false;
     var varEditor = newEditor();
     
     OpenedEditorFiles :
     for ( var vf = 0; vf < editorsCount(); vf++ )
     {
         var actEd = newEditor();
         actEd.assignEditorByIndex( vf );
         var actEdFN = actEd.fileName();
         if ( actEdFN == filename )
         {
			   isOpened = true;
			   break OpenedEditorFiles;
			}
	  }
	  return isOpened;
}



















function saveBeforeJumpPos( activeEditor )
{
    var activeFileName = activeEditor.fileName();
    var carx = activeEditor.caretX();
    var cary = activeEditor.caretY();
    var fso = new ActiveXObject("Scripting.FileSystemObject");
    var fs = fso.OpenTextFile( '../savedpos.txt', 8, true );
    fs.WriteLine( activeFileName + ',' + carx + ',' + cary );
    fs.Close();
}
