var MODULE_NAME  = "Goto previous macro head";
var MODULE_VER   = "1.0";
var MODULE_TITLE = "Searches for the head of the macro";
function Init() {
    menuName = "&" + MODULE_NAME;
    subMenu = "&" + "DMIS";
    addMenuItem(menuName, subMenu, "main", "CTRL+SHIFT+[");
}


function main() 
{
var	ed = neweditor();
ed.assignActiveEditor();
var text = new String(ed.text());
var curx = ed.caretX();
var cury = ed.caretY();
var pos = indexInText(text, curx, cury); //index correction counted in indexInText
var macHeadY = getMacroHeadPos( text, pos, cury );
ed.setCaretPos( 0, macHeadY );
}

function getMacroHeadPos( text, pos, cury )
{
	var textAbove = new String();
	textAbove = text.substring(0,pos);
 	var newlineIndex = textAbove.lastIndexOf( "\nMACRO" );
 	var textBtw = new String();
 	textBtw = textAbove.substring( newlineIndex );
 	var reg = new RegExp("\n","g");  
	var linesBtw = textBtw.match( reg );
	var numOfLinesBtw = linesBtw.length;
	return (cury - numOfLinesBtw + 1);
}





function indexInText(text, curx, cury) 
{ //function for lib WSH-PSPad
	// calculate linear coordinate in String text, based on cursor coordinates 
	var i = 1; // from first line, not zero
	var pos = 0;
	var cursymb = new String();
	while (i < cury) 
	{
		pos = text.indexOf("\n",pos);
		pos++; // next search from next position
		i++;
	}
	cursymb = text.charAt(pos);
	if ((cursymb == "\n") || (cursymb == "\r") || (cursymb == "\f")) {
		pos++;
	}
	pos = pos + curx - 1; // Array index from 0, string index from 1

return pos;
}
